Attribute VB_Name = "modDesktop"
Option Explicit
Global oServer As core.CServer
Public Declare Function GetNextWindow Lib "user32" Alias "GetWindow" (ByVal hwnd As Long, ByVal wFlag As Long) As Long
Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cX As Long, ByVal cY As Long, ByVal wFlags As Long) As Long
Public Declare Function GetDesktopWindow Lib "user32" () As Long
Public Declare Function PaintDesktop Lib "user32" (ByVal hdc As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Sub CopyMemoryDestAddr Lib "kernel32" Alias "RtlMoveMemory" (ByVal hpvDest&, hpvSource As Any, ByVal cbCopy As Long)
Public Declare Sub CopyMemorySrcAddr Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, ByVal hpvSource&, ByVal cbCopy As Long)
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Type WINDOWPOS
    hwnd As Long
    hWndInsertAfter As Long
    X As Long
    Y As Long
    cX As Long
    cY As Long
    flags As Long
End Type

Global Const SWP_NOACTIVATE = &H10
Global Const GW_HWNDNEXT = 2

Global Const SWP_DRAWFRAME = &H20
Global Const SWP_NOMOVE = &H2
Global Const SWP_NOSIZE = &H1
Global Const GWL_WNDPROC = (-4)

Global Const WM_WINDOWPOSCHANGING = &H46
Global Const WM_LBUTTONDOWN = &H201
Global Const WM_LBUTTONUP = &H202
Global Const WM_LBUTTONDBLCLK = &H203
Global Const WM_RBUTTONDOWN = &H204
Global Const WM_RBUTTONUP = &H205
Global Const WM_RBUTTONDBLCLK = &H206
Global Const WM_MBUTTONDOWN = &H207
Global Const WM_MBUTTONUP = &H208
Global Const WM_MBUTTONDBLCLK = &H209
Global Const WM_USER = &H400
Global Const WM_MENUSELECT = &H11F
Global Const WM_COMMAND = &H111
Global Const WM_SYSCOMMAND = &H112

Global Const HWND_BOTTOM = 1

Public OldWindowProc As Long
Public Function NewWindowProc(ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

    Dim WP As WINDOWPOS
    Dim sCommand As String
    
    Select Case msg
        Case WM_WINDOWPOSCHANGING
            CopyMemorySrcAddr WP, lParam, LenB(WP)
            WP.hWndInsertAfter = HWND_BOTTOM
            CopyMemoryDestAddr lParam, WP, LenB(WP)
            NewWindowProc = 0&
        Case WM_LBUTTONDOWN
            sCommand = oServer.GetKey(frmDesktop.Tag, "lbuttondown")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            NewWindowProc = 0&
        Case WM_LBUTTONUP
            sCommand = oServer.GetKey(frmDesktop.Tag, "lbuttonup")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            NewWindowProc = 0&
        Case WM_LBUTTONDBLCLK
            sCommand = oServer.GetKey(frmDesktop.Tag, "lbuttondblclk")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            NewWindowProc = 0&
        Case WM_RBUTTONDOWN
            sCommand = oServer.GetKey(frmDesktop.Tag, "rbuttondown")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            NewWindowProc = 0&
        Case WM_RBUTTONUP
            sCommand = oServer.GetKey(frmDesktop.Tag, "rbuttonup")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            NewWindowProc = 0&
        Case WM_RBUTTONDBLCLK
            sCommand = oServer.GetKey(frmDesktop.Tag, "rbuttondblclk")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            NewWindowProc = 0&
        Case WM_MBUTTONDOWN
            sCommand = oServer.GetKey(frmDesktop.Tag, "mbuttondown")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            NewWindowProc = 0&
        Case WM_MBUTTONUP
            sCommand = oServer.GetKey(frmDesktop.Tag, "mbuttonup")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            NewWindowProc = 0&
        Case WM_MBUTTONDBLCLK
            sCommand = oServer.GetKey(frmDesktop.Tag, "mbuttondblclk")
            If sCommand <> "" Then
                oServer.Execute sCommand
            End If
            NewWindowProc = 0&
    End Select
    
    NewWindowProc = CallWindowProc(OldWindowProc, hwnd, msg, wParam, lParam)

End Function
Public Function GetAddress(ByVal lngAddr As Long) As Long
    
    ''Used with AddressOf to return the address in memory of a procedure.

    GetAddress = lngAddr&
    
End Function
